import java.io.*;
import java.util.*;

public class xorand_ma_java {
    String fileName = "";

    final int B = 20;
    int[] a;
    int[] inv;
    int[] sz;
    int[] fixed;

    void clear() {
        Arrays.fill(sz, 0);
    }

    void add(int x) {
        int u = 0;
        for (int i = B - 1; i >= 0; i--) {
            sz[u]++;
            u = 2 * u + 1 + ((x >> i) & 1);
        }
        sz[u]++;
    }

    int get_less(int x) {
        int ans = 0;
        int u = 0;
        for (int i = B - 1; i >= 0; i--) {
            if (((x >> i) & 1) == 1) {
                ans += sz[2 * u + 1 + inv[i]];
            }
            u = 2 * u + 1 + (((x >> i) & 1) ^ inv[i]);
        }
        return ans;
    }

    void update() {
        clear();
        for (int anA : a) {
            int a1 = 0;
            for (int j = 0; j < B; j++) {
                if (fixed[j] != -1) {
                    a1 |= fixed[j] << j;
                } else {
                    a1 |= (inv[j] ^ ((anA >> j) & 1)) << j;
                }
            }
            add(a1);
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        int q = nextInt();
        a = new int[n];
        fixed = new int[B];
        inv = new int[B];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        Arrays.fill(fixed, -1);
        sz = new int[4 * (1 << B)];

        update();

        for (int i = 0; i < q; i++) {
            String type = nextToken();

            if (type.equals("?")) {
                int l = nextInt();
                int r = nextInt();
                out.println(get_less(r + 1) - get_less(l));
            } else if (type.equals("and")) {
                int v = nextInt();
                boolean rebuild = false;
                for (int b = 0; b < B; b++) {
                    if (((v >> b) & 1) == 0) {
                        if (fixed[b] == -1) {
                            fixed[b] = 0;
                            inv[b] = 0;
                            rebuild = true;
                        } else if (fixed[b] == 1) {
                            fixed[b] = 0;
                            inv[b] ^= 1;
                        }
                    }
                }
                if (rebuild) {
                    update();
                }
            } else if (type.equals("xor")) {
                int v = nextInt();
                for (int b = 0; b < B; b++) {
                    if (((v >> b) & 1) == 1) {
                        if (fixed[b] != -1) {
                            fixed[b] ^= 1;
                        }
                        inv[b] ^= 1;
                    }
                }
            }
        }
    }

    public void run() {
        try {
            if (fileName.equals("")) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out);
            } else if (fileName.equals("txt")) {
                br = new BufferedReader(new FileReader("input.txt"));
                out = new PrintWriter("output.txt");
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new xorand_ma_java().run();
    }

}